<!DOCTYPE html>
<html lang="en">

<head>
  <title>orderDetail</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

</head>

<body onload="onPageLoading()">
  <div class=" container">
    <h1 class=" text-center" style="margin-bottom: 20px;">Order Detail</h1>
    <div class="row ">
      <div class="col-sm-6">
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="order-code">Order Code</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-order-code" aria-describedby="ordercodeHelp"
              placeholder="">
          </div>
        </div>
        <div class=" row form-group">
          <div class="col-sm-4 text-right">
            <label for="sizepizza">Đường kính Pizza</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-duongkinh" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="drink">Đồ uống</label>
          </div>
          <div class="col-sm-8">
            <select id="select-drink" type="text" class="form-control">
              <option value="0" selected>Chọn đồ uống</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="voucherId">Voucher ID</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-voucherId" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="salad">Salad</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-salad" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="discount">Giảm giá</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-discount" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="email">Email</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-email" placeholder="">
          </div>
        </div>
        <div class=" row form-group">
          <div class="col-sm-4 text-right">
            <label for="address">Địa chỉ</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-address" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4">
            <label for="status">Trạng thái đơn hàng</label>
          </div>
          <div class="col-sm-8">
            <select id="select-status" type="text" class="form-control">
              <option value="NOT_SELECTED_STATUS">Trạng thái</option>
              <option value="open">Open</option>
              <option value="confirmed">Confirm</option>
              <option value="cancel">Cancel</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="updateDate">Ngày cập nhật</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-updateDate" placeholder="">
          </div>
        </div>
        <div class="row">
          <div class="col-sm-10 text-right">
            <button onclick="onBtnConfirmClick()" type="button" class="btn btn-success">Confirm</button>
            <button onclick="onBtnCancelClick()" type="button" class="btn btn-primary">Cancel</button>
            <button onclick="onBtnDeleteClick()" type="button" class="btn btn-danger">Delete</button>
          </div>
        </div>
      </div>
      <div class="col-sm-6">
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="combo-size">Cỡ Combo</label>
          </div>
          <div class="col-sm-8">
            <select id="select-combo-size" type="text" class="form-control">
              <option value="NOT_SELECTED_COMBO">Chọn cỡ Combo (Combo size)</option>
              <option value="S">Nhỏ</option>
              <option value="M">Vừa</option>
              <option value="L">Lớn</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="suongnuong">Sườn nướng (miếng)</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-suongnuong" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="soluong-drink">Số lượng nước uống</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-soluong-drink" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="voucherId">Loại pizza</label>
          </div>
          <div class="col-sm-8">
            <select id="select-pizza-type" type="text" class="form-control">
              <option value="NOT_SELECTED_PIZZA">Chọn loại pizza</option>
              <option value="SeaFood">Hải sản</option>
              <option value="Hawaii">Hawaii</option>
              <option value="Bacon">Thịt hun khói</option>
            </select>
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="salad">Thành tiền</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-total-prize" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="discount">Họ và tên</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-fullname" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="email">Số điện thoại</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-phonenumber" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="address">Lời nhắn</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-message" placeholder="">
          </div>
        </div>
        <div class="row form-group">
          <div class="col-sm-4 text-right">
            <label for="address">Ngày tạo đơn</label>
          </div>
          <div class="col-sm-8">
            <input type="text" class="form-control" id="input-date-order" placeholder="">
          </div>
        </div>
      </div>
      <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL_ORDERS = "http://203.171.20.210:8080/devcamp-pizza365/orders";
        const gBASE_URL_DRINK = "http://203.171.20.210:8080/devcamp-pizza365/drinks";
        const gREQUEST_DELETE_SUCCESS = 204;
        let gID;
        let gORDER_CODE;
        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
          // Đường dẫn gọi đến trang
          var vUrlString = window.location.href;

          //Tạo đối tượng URL để truy vấn tham số id và order code
          var vUrl = new URL(vUrlString);
          console.log(vUrl);

          //Lấy dữ liệu id và order Code
          gID = vUrl.searchParams.get("id");
          gORDER_CODE = vUrl.searchParams.get("ordercode");

          //Kiểm tra tham số id và ordercode
          var gINDEX_LIST_VIEW = "indexListView.html";

          if (gID === null || gID === "") {
            alert("Không có ID của đơn hàng");
            window.location.href = gINDEX_LIST_VIEW;
          }

          if (gORDER_CODE === null || gORDER_CODE === "") {
            alert('Không có order Code');
            window.location.href = gINDEX_LIST_VIEW;
          }
          console.log("id: ", gID);
          console.log("order Code: ", gORDER_CODE);
          // Gọi hàm đổ dữ liệu vào select drink
          loadDataDrinkList();

          // Gọi Api lấy thông tin đơn hàng
          callApiGetOrderInfo(gORDER_CODE);
        }

        //Hàm nhấn nút xác nhận
        function onBtnConfirmClick() {
          var vUrlString = window.location.href;
          var vUrl = new URL(vUrlString);

          var vID = vUrl.searchParams.get("id");
          console.log(vID);

          var vObjectRequest = {
            trangThai: ""
          }
          // Hàm thu thập dữ liệu
          thuThapDuLieu(vObjectRequest);
          //Hàm kiểm tra dữ liệu
          var duLieuHopLe = kiemTraStatusConfirm(vObjectRequest);

          if (duLieuHopLe) {
            // Gọi hàm Api Update đơn hàng
            callApiUpdateOrder(vID);

          }
        }
        //Hàm nhấn nút hủy đơn hàng
        function onBtnCancelClick() {
          var vUrlString = window.location.href;
          var vUrl = new URL(vUrlString);

          var vID = vUrl.searchParams.get("id");
          console.log(vID);
          var vObjectRequest = {
            trangThai: ""
          }

          // Hàm thu thập dữ liệu
          thuThapDuLieu(vObjectRequest);


          //Hàm kiểm tra dữ liệu
          var duLieuHopLe = kiemTraStatusCancel(vObjectRequest);

          if (duLieuHopLe) {
            // gọi hàm Api cancel đơn hàng
            callApiUpdateCancelOrder(vID);

          }
        }

        // Hàm nhấn nút xóa đơn hàng
        function onBtnDeleteClick() {
          var vUrlString = window.location.href;
          var vUrl = new URL(vUrlString);
          var vID = vUrl.searchParams.get("id");
          console.log(vID);

          confirm("Bạn chắc chắn muốn xóa đơn hàng này không?")
          if (confirm) {
            var vXmlHttpOrder = new XMLHttpRequest();
            vXmlHttpOrder.open("DELETE", gBASE_URL_ORDERS + "/" + vID, true);
            vXmlHttpOrder.send();
            vXmlHttpOrder.onreadystatechange = function () {
              if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK
                && this.status == gREQUEST_DELETE_SUCCESS) {
                alert("Delete order " + vID + " thành công!");
              } else if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK
                && this.status !== gREQUEST_DELETE_SUCCESS) {
                alert("Delete order " + vID + " không thành công!")
              }
            }
          }
        }

        /*** REGION4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        //Hàm thu thập dữ liệu 
        function thuThapDuLieu(paramObjectRequest) {

          var vSelectStatus = document.getElementById("select-status");

          paramObjectRequest.trangThai = vSelectStatus.value;

        }
        // Hàm kiểm tra trạng thái confirm
        function kiemTraStatusConfirm(paramObjectRequest) {

          if (paramObjectRequest.trangThai === "cancel") {
            alert("Đơn hàng đã bị hủy không thể confirm")
            return false;
          }

          if (paramObjectRequest.trangThai === "confirmed") {
            alert("Đơn hàng đã được confirm")
            return false;
          }
          return true;
        }

        // Hàm kiểm tra trạng thái cancel
        function kiemTraStatusCancel(paramObjectRequest) {

          if (paramObjectRequest.trangThai === "cancel") {
            alert("Đơn hàng đã được cancel")
            return false;
          }

          if (paramObjectRequest.trangThai === "confirmed") {
            alert("Đơn hàng đã được confirm không thể cancel")
            return false;
          }

          return true;
        }


        // Hàm gọi Api lấy thông tin order theo order Code
        function callApiGetOrderInfo(paramOrderCode) {
          var vXmlHttpGetAllOrders = new XMLHttpRequest();
          vXmlHttpGetAllOrders.open("GET", gBASE_URL_ORDERS + "/" + paramOrderCode, false);
          vXmlHttpGetAllOrders.send();
          if (vXmlHttpGetAllOrders.status === gREQUEST_STATUS_OK) {
            displayDataToForm(vXmlHttpGetAllOrders.responseText);
          }

        }
        //Hàm hiển thị dữ liệu vào form
        function displayDataToForm(paramOrderResponse) {

          var vAllOrderObj = JSON.parse(paramOrderResponse);
          console.log(vAllOrderObj);

          //Gọi hàm chuyển đổi định dạng ngày cập nhật
          var vNgayCapNhat = formatDate(vAllOrderObj.ngayCapNhat);

          //Gọi hàm chuyển đổi định dạng ngày tạo
          var vNgayTao = formatDate(vAllOrderObj.ngayTao);

          var vInputOrderCode = document.getElementById("input-order-code");
          var vInputDuongKinhPizza = document.getElementById("input-duongkinh");
          var vSelectDrink = document.getElementById("select-drink");
          var vInputVoucherId = document.getElementById("input-voucherId");
          var vInputSalad = document.getElementById("input-salad");
          var vInputDiscount = document.getElementById("input-discount");
          var vInputEmail = document.getElementById("input-email");
          var vInputAddress = document.getElementById("input-address");
          var vSelectStatus = document.getElementById("select-status");
          var vInputUpdateDay = document.getElementById("input-updateDate");
          var vInputComboSize = document.getElementById("select-combo-size");
          var vInputSuonNuong = document.getElementById("input-suongnuong");
          var vInputNumberDrink = document.getElementById("input-soluong-drink");
          var vSelectTypePizza = document.getElementById("select-pizza-type");
          var vInputTotalPrize = document.getElementById("input-total-prize");
          var vInputFullName = document.getElementById("input-fullname");
          var vInputPhoneNumber = document.getElementById("input-phonenumber");
          var vInputMessage = document.getElementById("input-message");
          var vInputDateOrder = document.getElementById("input-date-order");

          vInputOrderCode.value = vAllOrderObj.orderCode;
          vInputDuongKinhPizza.value = vAllOrderObj.duongKinh;
          vSelectDrink.value = vAllOrderObj.idLoaiNuocUong;
          vInputVoucherId.value = vAllOrderObj.idVourcher;
          vInputSalad.value = vAllOrderObj.salad;
          vInputDiscount.value = vAllOrderObj.giamGia;
          vInputEmail.value = vAllOrderObj.email;
          vInputAddress.value = vAllOrderObj.diaChi;
          vSelectStatus.value = vAllOrderObj.trangThai;
          vInputUpdateDay.value = vNgayCapNhat;
          vInputComboSize.value = vAllOrderObj.kichCo;
          vInputSuonNuong.value = vAllOrderObj.suon;
          vInputNumberDrink.value = vAllOrderObj.soLuongNuoc;
          vSelectTypePizza.value = vAllOrderObj.loaiPizza;
          vInputTotalPrize.value = vAllOrderObj.thanhTien;
          vInputFullName.value = vAllOrderObj.hoTen;
          vInputPhoneNumber.value = vAllOrderObj.soDienThoai;
          vInputMessage.value = vAllOrderObj.loiNhan;
          vInputDateOrder.value = vNgayTao;
        }

        // Hàm format ngày từ Response 
        function formatDate(paramNgayCapNhat) {
          var dateString = `\/Date(${paramNgayCapNhat})\/`.substr(6);
          var currentTime = new Date(parseInt(dateString));
          var month = currentTime.getMonth() + 1;
          var day = currentTime.getDate();
          var year = currentTime.getFullYear();
          var date = day + "/" + month + "/" + year;
          console.log(date)
          return date;
        }

        // Hàm đổ dữ liệu list drink
        function loadDataDrinkList() {

          var vXmlHttpGetDrinkList = new XMLHttpRequest();
          vXmlHttpGetDrinkList.open("GET", gBASE_URL_DRINK, false);
          vXmlHttpGetDrinkList.send();
          if (vXmlHttpGetDrinkList.status === gREQUEST_STATUS_OK) {
            var vDrinkListObj = JSON.parse(vXmlHttpGetDrinkList.responseText);
            loadDataToSelectDrink(vDrinkListObj);
          }

        }
        // Hàm đổ dữ liệu list drink vào select
        function loadDataToSelectDrink(paramDrinkListObj) {
          console.log(paramDrinkListObj);
          var vSelectDrink = document.getElementById("select-drink");
          for (let bI = 0; bI < paramDrinkListObj.length; bI++) {
            var vOptionElement = document.createElement("option");
            vOptionElement.value = paramDrinkListObj[bI].maNuocUong;
            vOptionElement.text = paramDrinkListObj[bI].tenNuocUong;

            vSelectDrink.appendChild(vOptionElement);

          }

        };
        // Hàm Api Update đơn hàng confirm
        function callApiUpdateOrder(paramID) {
          var vObjectRequest = {
            trangThai: "confirmed"
          }
          var vOrderString = JSON.stringify(vObjectRequest);

          var vXmlHttpUpdateOrder = new XMLHttpRequest();
          vXmlHttpUpdateOrder.open("PUT", gBASE_URL_ORDERS + "/" + paramID);
          vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json");
          vXmlHttpUpdateOrder.send(vOrderString);
          vXmlHttpUpdateOrder.onreadystatechange =
            function () {
              if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {

                var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                console.log(vUpdatedOrder);
                alert("Confirm đơn hàng thành công")
                const vUrlOpenToListViewSite = "indexListView.html";
                window.location.href = vUrlOpenToListViewSite;
              } else if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status !== gREQUEST_STATUS_OK) {
                alert("Confirm đơn hàng không thành công")
              }
            }
        }

        // Hàm Api Update đơn hàng cancel
        function callApiUpdateCancelOrder(paramID) {
          var vObjectRequest = {
            trangThai: "cancel"
          }
          console.log(paramID);
          var vOrderString = JSON.stringify(vObjectRequest);
          var vXmlHttpUpdateOrder = new XMLHttpRequest();
          vXmlHttpUpdateOrder.open("PUT", gBASE_URL_ORDERS + "/" + paramID);
          vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");;
          vXmlHttpUpdateOrder.send(vOrderString);
          vXmlHttpUpdateOrder.onreadystatechange =
            function () {
              if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {

                var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                console.log(vUpdatedOrder);
                alert("Cancel đơn hàng thành công")
                const vUrlOpenToListViewSite = "indexListView.html";
                window.location.href = vUrlOpenToListViewSite;
              } else if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status !== gREQUEST_STATUS_OK) {
                alert("Cancel đơn hàng không thành công")
              }
            }
        }

      </script>
</body>

</html>